use crate::helper::settings::Settings;
use rocket::State;
use crate::database::controller::connector::establish_connection;
use diesel::RunQueryDsl;
use crate::database::model::units::RawUnit;

pub fn get_units(settings: &State<Settings>) -> Result<Vec<RawUnit>, diesel::result::Error>{
    use crate::schema::units::dsl::*;

    let connection = establish_connection(settings);
    match units.load::<RawUnit>(&connection){
        Ok(unit_list) => Ok(unit_list),
        Err(e) => {
            error!("Couldn't load unit list: {}", e);
            Err(e)
        }
    }
}