use crate::schema::members;
use chrono::NaiveDate;

/*#[derive(Debug, Copy, Clone, AsExpression, FromSqlRow, Deserialize, Serialize)]
#[sql_type = "SmallInt"]
pub enum Sex {
    UNKNOWN = 0,
    MALE = 1,
    FEMALE = 2,
    OTHER = 9,
}*/

#[derive(AsChangeset, Queryable, Clone, Deserialize, Serialize)]
#[table_name = "members"]
#[primary_key(entity_id)]
#[changeset_options(treat_none_as_null = "true")]
pub struct RawMember {
    pub(crate) entity_id: uuid::Uuid,
    pub(crate) users_id: Option<uuid::Uuid>,
    pub(crate) firstname: String,
    pub(crate) lastname: String,
    pub(crate) date_of_birth: Option<NaiveDate>,
    pub(crate) sex: Option<i16>,
    pub(crate) salutation: Option<String>,
    pub(crate) place_of_birth: Option<String>,
    pub(crate) academic_titles: Option<String>,
    pub(crate) personnel_number: Option<i32>,
    pub(crate) ui_language: Option<String>,
    pub(crate) nationality: Option<String>,
    pub(crate) entrance_date: Option<NaiveDate>,
    pub(crate) birth_name: Option<String>,
    pub(crate) iban: Option<String>,
    pub(crate) bic: Option<String>
}

#[derive(Insertable, Queryable, Clone, Deserialize, Serialize)]
#[table_name = "members"]
pub struct CreateMember{
    pub(crate) entity_id: uuid::Uuid,
    pub(crate) firstname: String,
    pub(crate) lastname: String,
    pub(crate) sex: i16,
    pub(crate) salutation: String,
    pub(crate) academic_titles: Option<String>,
    pub(crate) personnel_number: Option<i32>,
    pub(crate) entrance_date: Option<NaiveDate>,
}