use crate::schema::units;
use diesel::sql_types::*;

#[derive(Serialize, Deserialize, Queryable, Clone)]
pub struct RawUnit{
    pub(crate) unit_id: uuid::Uuid,
    pub(crate) name: String,
}

#[derive(Serialize, Deserialize, Queryable, Clone, QueryableByName)]
pub struct Unit{
    #[sql_type = "Uuid"]
    pub(crate) unit_id: uuid::Uuid,
    #[sql_type = "Text"]
    pub(crate) name: String,
    #[sql_type = "SmallInt"]
    pub(crate) crew: i16,
}