/// AlertClass represents css class used to style the alert
#[derive(Serialize)]
pub enum AlertClass {
    #[serde(rename = "alert-primary")]
    Primary,
    #[serde(rename = "alert-secondary")]
    Secondary,
    #[serde(rename = "alert-success")]
    Success,
    #[serde(rename = "alert-danger")]
    Danger,
    #[serde(rename = "alert-warning")]
    Warning,
    #[serde(rename = "alert-info")]
    Info,
    #[serde(rename = "alert-light")]
    Light,
    #[serde(rename = "alert-dark")]
    Dark,
}

/// Alert struct to use in templates to easily include alerts (e.g. displaying errors)
#[derive(Serialize)]
pub struct Alert {
    pub class: AlertClass,
    /// Message/content of the alert. Can be any html
    pub content: String,
}
