#[derive(Serialize, Deserialize, Queryable, Clone, Debug)]
pub struct ApiError {
    pub(crate) code: u16,
    pub(crate) description: String,
}

#[derive(Serialize, Deserialize, Queryable, Clone, Debug)]
pub struct ApiErrorWrapper {
    pub(crate) error: ApiError,
}

impl ApiError {
    pub fn new(code: u16, description: String) -> ApiError {
        ApiError { code, description }
    }
    pub fn to_wrapper(self) -> ApiErrorWrapper {
        ApiErrorWrapper { error: self }
    }
}
