use crate::modules::member_management::model::filter_form::FilterForm;
use rocket::request::{FormItems, FromForm};

/// FromForm implementation for FilterForms. Unfortunately rocket 0.45 has no support for multi-value elements yet.
/// See: https://github.com/SergioBenitez/Rocket/issues/205
/// It will be added in rocket 0.5, future coders may refactor this and replace it with the rocket implementation.
/// For now I need to use this crap.
/// TODO: change error type
impl<'a> FromForm<'a> for FilterForm {
    type Error = ();

    fn from_form(items: &mut FormItems<'a>, strict: bool) -> Result<FilterForm, ()> {
        let mut selected_groups: Vec<String> = Vec::new();

        for item in items {
            match item.key.as_str() {
                "selected_groups" => {
                    let value = item.value.url_decode().map_err(|_| ())?;
                    selected_groups.push(value);
                }
                _ if strict => return Err(()),
                _ => { /* allow extra value when not strict */ }
            }
        }

        Ok(FilterForm { selected_groups })
    }
}
