use crate::database::model::member_licenses::RawMemberLicense;
use crate::modules::member_management::model::licenses::MemberLicense;

impl From<RawMemberLicense> for MemberLicense {
    fn from(raw: RawMemberLicense) -> Self {
        let mut license: bool = true;

        let drive_permission = match raw.drive_permission {
            Some(drive_permission) => drive_permission,
            None => {
                license = false;
                false
            }
        };

        let member_license = MemberLicense {
            category_name: raw.name,
            category_description: raw.description,
            drive_permission,
            license,
        };
        member_license
    }
}
