use crate::database::model::members::RawMember;
use crate::modules::member_management::model::groups::Group;
use crate::modules::member_management::model::member::Member;

impl From<(RawMember, Vec<String>, Vec<Group>)> for Member {
    fn from(rawmember_permissions: (RawMember, Vec<String>, Vec<Group>)) -> Self {
        let raw_member = rawmember_permissions.0;
        let permissions = rawmember_permissions.1;
        let groups = rawmember_permissions.2;

        Member {
            entity_id: raw_member.entity_id,
            users_id: raw_member.users_id,
            firstname: raw_member.firstname,
            lastname: raw_member.lastname,
            date_of_birth: raw_member.date_of_birth,
            sex: raw_member.sex,
            salutation: raw_member.salutation,
            place_of_birth: raw_member.place_of_birth,
            academic_titles: raw_member.academic_titles,
            personnel_number: raw_member.personnel_number,
            ui_language: raw_member.ui_language,
            nationality: raw_member.nationality,
            entrance_date: raw_member.entrance_date,
            birth_name: raw_member.birth_name,
            iban: raw_member.iban,
            bic: raw_member.bic,
            permissions,
            groups,
        }
    }
}

/*impl<'a> From<(Member, &State<'a, Settings>, Member, String)> for MemberWithAccess {
    fn from(p: (Member, &State<'a, Settings>, Member, String)) -> Self {
        let member: Member = p.0;
        let settings: &State<Settings> = p.1;
        let requesting = p.2;
        let permission = p.3;

        let mut read =
            requesting.has_permission("modules.member_management.profile.view.all".to_string());
        if !read {
            read = check_member_has_access(
                settings,
                requesting.entity_id,
                member.entity_id,
                "modules.member_management.profile.view".to_string(),
            );
        };
        let mut write =
            requesting.has_permission("modules.member_management.profile.edit.all".to_string());
        if !write {
            write = check_member_has_access(
                settings,
                requesting.entity_id,
                member.entity_id,
                "modules.member_management.profile.edit".to_string(),
            );
        }
        MemberWithAccess {
            member,
            read,
            write,
        }
    }
}*/
