use crate::database::model::addresses::Address;
use crate::database::model::member_communication::CommunicationTarget;
use crate::helper::sitebuilder::model::general::{Footer, Header};
use crate::helper::sitebuilder::model::sidebar::Sidebar;
use crate::modules::member_management::model::groups::Group;
use crate::modules::member_management::model::licenses::MemberLicense;
use crate::modules::member_management::model::member::{Member, MemberWithAccess};
use crate::modules::member_management::model::qualifications::QualificationCategory;
use std::collections::HashMap;
use crate::database::model::units::Unit;
use crate::modules::member_management::model::login::Login;

#[derive(Serialize)]
pub struct MemberModuleSelection {
    pub header: Header,
    pub footer: Footer,
    pub sidebar: Sidebar,
    pub member_list: Vec<MemberWithAccess>,
    pub group_list: HashMap<uuid::Uuid, Group>,
}

#[derive(Serialize)]
pub struct EmptyMemberModuleProfile {
    pub header: Header,
    pub footer: Footer,
    pub sidebar: Sidebar,
}

#[derive(Serialize)]
pub struct MemberModuleProfile {
    pub header: Header,
    pub footer: Footer,
    pub member: Member,
    pub member_age: Option<i32>,
    pub address: Option<Address>,
    pub licenses: Vec<MemberLicense>,
    pub qualification_categories: Vec<QualificationCategory>,
    pub communication_targets: Vec<CommunicationTarget>,
    pub readonly: bool,
    pub sidebar: Sidebar,
    pub caller_permissions: Vec<String>,
    pub units: Vec<Unit>,
    pub login: Login,
}

#[derive(Serialize)]
pub struct MemberModuleCreate{
    pub header: Header,
    pub footer: Footer,
    pub sidebar: Sidebar,
}