pub mod modules {
    pub mod dashboard {
        pub const VIEW: &'static str = "modules.dashboard.view";
    }
    pub mod member_management {
        pub const SEARCH: &'static str = "modules.member_management.search";
        pub const VIEW: &'static str = "modules.member_management.view";
        pub mod list {
            pub const VIEW: &'static str = "modules.member_management.list.view";
        }
        pub mod iban_bic{
            pub const VIEW: &'static str = "modules.member_management.iban_bic.view";
            pub const EDIT: &'static str = "modules.member_management.iban_bic.edit";
        }
        pub mod groups {
            pub const VIEW: &'static str = "modules.member_management.groups.view";
            pub const EDIT: &'static str = "modules.member_management.groups.edit";
            pub const CREATE: &'static str = "modules.member_management.groups.create";
            pub const DELETE: &'static str = "modules.member_management.groups.delete";

            pub mod members {
                pub const VIEW: &'static str = "modules.member_management.groups.members.view";
                pub const EDIT: &'static str = "modules.member_management.groups.members.edit";
            }

            pub mod permissions {
                pub const VIEW: &'static str = "modules.member_management.groups.permissions.view";
                pub const EDIT: &'static str = "modules.member_management.groups.permissions.edit";
            }

            pub mod core {
                pub const EDIT: &'static str = "modules.member_management.groups.core.edit";
            }
        }
        pub mod profile {
            pub const VIEW: &'static str = "modules.member_management.profile.view";
            pub const EDIT: &'static str = "modules.member_management.profile.edit";
            pub const CREATE: &'static str = "modules.member_management.profile.create";
            pub const DELETE: &'static str = "modules.member_management.profile.delete";
            pub mod qualifications {
                pub const VIEW: &'static str =
                    "modules.member_management.profile.qualification.view";
                pub const EDIT: &'static str =
                    "modules.member_management.profile.qualifications.edit";
            }
            pub mod image {
                pub const VIEW: &'static str = "modules.member_management.profile.image.view";
                pub const EDIT: &'static str = "modules.member_management.profile.image.edit";
            }
            pub mod drive_permissions_licenses {
                pub const VIEW: &'static str =
                    "modules.member_management.profile.drive_permissions_licenses.view";
                pub const EDIT: &'static str =
                    "modules.member_management.profile.drive_permissions_licenses.edit";
            }
            pub mod communication {
                pub const VIEW: &'static str =
                    "modules.member_management.profile.communication.view";
                pub const EDIT: &'static str =
                    "modules.member_management.profile.communication.edit";
            }
            pub mod list {
                pub const VIEW: &'static str = "modules.member_management.list.view";
            }
            pub mod groups {
                pub const VIEW: &'static str = "modules.member_management.profile.groups.view";
                pub const EDIT: &'static str = "modules.member_management.profile.groups.edit";
            }
            pub mod core {
                pub const EDIT: &'static str = "modules.member_management.profile.core.edit";
            }
        }
    }
    pub mod event_management {
        pub const VIEW: &'static str = "modules.event_management.view";
    }
    pub mod configuration {
        pub mod fields {
            pub mod communication_types {
                pub const VIEW: &'static str =
                    "modules.configuration.fields.communication_types.view";
            }
        }
    }
    pub mod units{
        pub const EDIT: &'static str = "modules.units.edit";
        pub const CREATE: &'static str = "modules.units.create";
        pub const DELETE: &'static str = "modules.units.delete";
        pub mod members {
            pub const VIEW: &'static str = "modules.units.members.view";
            pub const EDIT: &'static str = "modules.units.members.view";
        }
    }
}
